// **********************************************************************
//
// Copyright (c) 2003-2015 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************
//
// Ice version 3.6.0
//
// <auto-generated>
//
// Generated from file `Instrumentation.ice'
//
// Warning: do not edit this file.
//
// </auto-generated>
//

#ifndef __IceStorm_Instrumentation_h__
#define __IceStorm_Instrumentation_h__

#include <IceUtil/PushDisableWarnings.h>
#include <Ice/ProxyF.h>
#include <Ice/ObjectF.h>
#include <Ice/Exception.h>
#include <Ice/LocalObject.h>
#include <Ice/StreamHelpers.h>
#include <Ice/Proxy.h>
#include <Ice/GCObject.h>
#include <Ice/AsyncResult.h>
#include <Ice/Incoming.h>
#include <Ice/FactoryTableInit.h>
#include <IceUtil/ScopedArray.h>
#include <IceUtil/Optional.h>
#include <Ice/StreamF.h>
#include <Ice/Instrumentation.h>
#include <IceStorm/IceStorm.h>
#include <IceUtil/UndefSysMacros.h>

#ifndef ICE_IGNORE_VERSION
#   if ICE_INT_VERSION / 100 != 306
#       error Ice version mismatch!
#   endif
#   if ICE_INT_VERSION % 100 > 50
#       error Beta header file detected
#   endif
#   if ICE_INT_VERSION % 100 < 0
#       error Ice patch level mismatch!
#   endif
#endif

namespace IceProxy
{

}

namespace IceStorm
{

namespace Instrumentation
{

class TopicObserver;
bool operator==(const TopicObserver&, const TopicObserver&);
bool operator<(const TopicObserver&, const TopicObserver&);
::Ice::LocalObject* upCast(::IceStorm::Instrumentation::TopicObserver*);
typedef ::IceInternal::Handle< ::IceStorm::Instrumentation::TopicObserver> TopicObserverPtr;

class SubscriberObserver;
bool operator==(const SubscriberObserver&, const SubscriberObserver&);
bool operator<(const SubscriberObserver&, const SubscriberObserver&);
::Ice::LocalObject* upCast(::IceStorm::Instrumentation::SubscriberObserver*);
typedef ::IceInternal::Handle< ::IceStorm::Instrumentation::SubscriberObserver> SubscriberObserverPtr;

class ObserverUpdater;
bool operator==(const ObserverUpdater&, const ObserverUpdater&);
bool operator<(const ObserverUpdater&, const ObserverUpdater&);
::Ice::LocalObject* upCast(::IceStorm::Instrumentation::ObserverUpdater*);
typedef ::IceInternal::Handle< ::IceStorm::Instrumentation::ObserverUpdater> ObserverUpdaterPtr;

class TopicManagerObserver;
bool operator==(const TopicManagerObserver&, const TopicManagerObserver&);
bool operator<(const TopicManagerObserver&, const TopicManagerObserver&);
::Ice::LocalObject* upCast(::IceStorm::Instrumentation::TopicManagerObserver*);
typedef ::IceInternal::Handle< ::IceStorm::Instrumentation::TopicManagerObserver> TopicManagerObserverPtr;

}

}

namespace IceStorm
{

namespace Instrumentation
{

enum SubscriberState
{
    SubscriberStateOnline,
    SubscriberStateOffline,
    SubscriberStateError
};

}

}

namespace Ice
{
template<>
struct StreamableTraits< ::IceStorm::Instrumentation::SubscriberState>
{
    static const StreamHelperCategory helper = StreamHelperCategoryEnum;
    static const int minValue = 0;
    static const int maxValue = 2;
    static const int minWireSize = 1;
    static const bool fixedLength = false;
};

}

namespace IceProxy
{

}

namespace IceStorm
{

namespace Instrumentation
{

class TopicObserver : virtual public ::Ice::Instrumentation::Observer
{
public:

    typedef TopicObserverPtr PointerType;

    virtual void published() = 0;

    virtual void forwarded() = 0;
};

inline bool operator==(const TopicObserver& l, const TopicObserver& r)
{
    return static_cast<const ::Ice::LocalObject&>(l) == static_cast<const ::Ice::LocalObject&>(r);
}

inline bool operator<(const TopicObserver& l, const TopicObserver& r)
{
    return static_cast<const ::Ice::LocalObject&>(l) < static_cast<const ::Ice::LocalObject&>(r);
}

class SubscriberObserver : virtual public ::Ice::Instrumentation::Observer
{
public:

    typedef SubscriberObserverPtr PointerType;

    virtual void queued(::Ice::Int) = 0;

    virtual void outstanding(::Ice::Int) = 0;

    virtual void delivered(::Ice::Int) = 0;
};

inline bool operator==(const SubscriberObserver& l, const SubscriberObserver& r)
{
    return static_cast<const ::Ice::LocalObject&>(l) == static_cast<const ::Ice::LocalObject&>(r);
}

inline bool operator<(const SubscriberObserver& l, const SubscriberObserver& r)
{
    return static_cast<const ::Ice::LocalObject&>(l) < static_cast<const ::Ice::LocalObject&>(r);
}

class ObserverUpdater : virtual public ::Ice::LocalObject
{
public:

    typedef ObserverUpdaterPtr PointerType;

    virtual void updateTopicObservers() = 0;

    virtual void updateSubscriberObservers() = 0;
};

inline bool operator==(const ObserverUpdater& l, const ObserverUpdater& r)
{
    return static_cast<const ::Ice::LocalObject&>(l) == static_cast<const ::Ice::LocalObject&>(r);
}

inline bool operator<(const ObserverUpdater& l, const ObserverUpdater& r)
{
    return static_cast<const ::Ice::LocalObject&>(l) < static_cast<const ::Ice::LocalObject&>(r);
}

class TopicManagerObserver : virtual public ::Ice::LocalObject
{
public:

    typedef TopicManagerObserverPtr PointerType;

    virtual ::IceStorm::Instrumentation::TopicObserverPtr getTopicObserver(const ::std::string&, const ::std::string&, const ::IceStorm::Instrumentation::TopicObserverPtr&) = 0;

    virtual ::IceStorm::Instrumentation::SubscriberObserverPtr getSubscriberObserver(const ::std::string&, const ::std::string&, const ::Ice::ObjectPrx&, const ::IceStorm::QoS&, const ::IceStorm::TopicPrx&, ::IceStorm::Instrumentation::SubscriberState, const ::IceStorm::Instrumentation::SubscriberObserverPtr&) = 0;

    virtual void setObserverUpdater(const ::IceStorm::Instrumentation::ObserverUpdaterPtr&) = 0;
};

inline bool operator==(const TopicManagerObserver& l, const TopicManagerObserver& r)
{
    return static_cast<const ::Ice::LocalObject&>(l) == static_cast<const ::Ice::LocalObject&>(r);
}

inline bool operator<(const TopicManagerObserver& l, const TopicManagerObserver& r)
{
    return static_cast<const ::Ice::LocalObject&>(l) < static_cast<const ::Ice::LocalObject&>(r);
}

}

}

#include <IceUtil/PopDisableWarnings.h>
#endif
